-- This script was generated by the ERD tool in pgAdmin 4.
-- Please log an issue at https://redmine.postgresql.org/projects/pgadmin4/issues/new if you find any bugs, including reproduction steps.
BEGIN;


CREATE TABLE IF NOT EXISTS public.causas
(
    causa_id bigserial NOT NULL,
    nombre_causa character varying(50) COLLATE pg_catalog."default",
    CONSTRAINT causas_pkey PRIMARY KEY (causa_id),
    CONSTRAINT causas_nombre_causa_key UNIQUE (nombre_causa)
);

CREATE TABLE IF NOT EXISTS public.donaciones
(
    donacion_id bigserial NOT NULL,
    usuario_id integer,
    oportunidad_id integer,
    monto numeric(10, 2),
    fecha_donacion date,
    estado character varying(20) COLLATE pg_catalog."default",
    CONSTRAINT donaciones_pkey PRIMARY KEY (donacion_id)
);

CREATE TABLE IF NOT EXISTS public.eventos
(
    evento_id bigserial NOT NULL,
    oportunidad_id integer,
    fecha_evento date,
    voluntarios_inscritos integer[],
    CONSTRAINT eventos_pkey PRIMARY KEY (evento_id)
);

CREATE TABLE IF NOT EXISTS public.inscripcioneseventos
(
    inscripcion_id bigserial NOT NULL,
    usuario_id integer,
    evento_id integer,
    CONSTRAINT inscripcioneseventos_pkey PRIMARY KEY (inscripcion_id)
);

CREATE TABLE IF NOT EXISTS public.oportunidades
(
    oportunidad_id bigserial NOT NULL,
    entidad_id integer,
    titulo character varying(100) COLLATE pg_catalog."default",
    descripcion text COLLATE pg_catalog."default",
    ubicacion character varying(100) COLLATE pg_catalog."default",
    fecha date,
    duracion integer,
    causa character varying(50) COLLATE pg_catalog."default",
    CONSTRAINT oportunidades_pkey PRIMARY KEY (oportunidad_id)
);

CREATE TABLE IF NOT EXISTS public.perfilesusuarios
(
    perfil_id bigserial NOT NULL,
    usuario_id integer,
    detalles_personales text COLLATE pg_catalog."default",
    intereses text[] COLLATE pg_catalog."default",
    habilidades text[] COLLATE pg_catalog."default",
    disponibilidad text[] COLLATE pg_catalog."default",
    CONSTRAINT perfilesusuarios_pkey PRIMARY KEY (perfil_id)
);

CREATE TABLE IF NOT EXISTS public.permisos
(
    permiso_id bigserial NOT NULL,
    nombre_permiso character varying(100) COLLATE pg_catalog."default",
    CONSTRAINT permisos_pkey PRIMARY KEY (permiso_id),
    CONSTRAINT permisos_nombre_permiso_key UNIQUE (nombre_permiso)
);

CREATE TABLE IF NOT EXISTS public.roles
(
    rol_id bigserial NOT NULL,
    nombre_rol character varying(50) COLLATE pg_catalog."default",
    CONSTRAINT roles_pkey PRIMARY KEY (rol_id),
    CONSTRAINT roles_nombre_rol_key UNIQUE (nombre_rol)
);

CREATE TABLE IF NOT EXISTS public.rolespermisos
(
    rol_permiso_id bigserial NOT NULL,
    rol_id integer,
    permiso_id integer,
    CONSTRAINT rolespermisos_pkey PRIMARY KEY (rol_permiso_id)
);

CREATE TABLE IF NOT EXISTS public.usuarios
(
    usuario_id bigserial NOT NULL,
    nombre character varying(50) COLLATE pg_catalog."default",
    apellido character varying(50) COLLATE pg_catalog."default",
    correo_electronico character varying(100) COLLATE pg_catalog."default",
    contrasena character varying(100) COLLATE pg_catalog."default",
    tipo_usuario character varying(20) COLLATE pg_catalog."default",
    CONSTRAINT usuarios_pkey PRIMARY KEY (usuario_id),
    CONSTRAINT usuarios_correo_electronico_key UNIQUE (correo_electronico)
);

CREATE TABLE IF NOT EXISTS public.usuariosroles
(
    usuario_rol_id bigserial NOT NULL,
    usuario_id integer,
    rol_id integer,
    CONSTRAINT usuariosroles_pkey PRIMARY KEY (usuario_rol_id)
);

CREATE TABLE IF NOT EXISTS public.valoracionescomentarios
(
    valoracion_id bigserial NOT NULL,
    usuario_id integer,
    entidad_id integer,
    puntuacion integer,
    comentario text COLLATE pg_catalog."default",
    fecha_valoracion date,
    CONSTRAINT valoracionescomentarios_pkey PRIMARY KEY (valoracion_id)
);

ALTER TABLE IF EXISTS public.donaciones
    ADD CONSTRAINT donaciones_oportunidad_id_fkey FOREIGN KEY (oportunidad_id)
    REFERENCES public.oportunidades (oportunidad_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.donaciones
    ADD CONSTRAINT donaciones_usuario_id_fkey FOREIGN KEY (usuario_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.eventos
    ADD CONSTRAINT eventos_oportunidad_id_fkey FOREIGN KEY (oportunidad_id)
    REFERENCES public.oportunidades (oportunidad_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.inscripcioneseventos
    ADD CONSTRAINT inscripcioneseventos_evento_id_fkey FOREIGN KEY (evento_id)
    REFERENCES public.eventos (evento_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.inscripcioneseventos
    ADD CONSTRAINT inscripcioneseventos_usuario_id_fkey FOREIGN KEY (usuario_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.oportunidades
    ADD CONSTRAINT oportunidades_entidad_id_fkey FOREIGN KEY (entidad_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.perfilesusuarios
    ADD CONSTRAINT perfilesusuarios_usuario_id_fkey FOREIGN KEY (usuario_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.rolespermisos
    ADD CONSTRAINT rolespermisos_permiso_id_fkey FOREIGN KEY (permiso_id)
    REFERENCES public.permisos (permiso_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.rolespermisos
    ADD CONSTRAINT rolespermisos_rol_id_fkey FOREIGN KEY (rol_id)
    REFERENCES public.roles (rol_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.usuariosroles
    ADD CONSTRAINT usuariosroles_rol_id_fkey FOREIGN KEY (rol_id)
    REFERENCES public.roles (rol_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.usuariosroles
    ADD CONSTRAINT usuariosroles_usuario_id_fkey FOREIGN KEY (usuario_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.valoracionescomentarios
    ADD CONSTRAINT valoracionescomentarios_entidad_id_fkey FOREIGN KEY (entidad_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;


ALTER TABLE IF EXISTS public.valoracionescomentarios
    ADD CONSTRAINT valoracionescomentarios_usuario_id_fkey FOREIGN KEY (usuario_id)
    REFERENCES public.usuarios (usuario_id) MATCH SIMPLE
    ON UPDATE NO ACTION
    ON DELETE NO ACTION;

END;